#
#            Automate Method
#
$evm.log("info", "lampsrv Automate Method Started")
@method = 'buildrequest'
@log_prefix = "[#{@method}]"
@debug = true
#
#            Method Code Goes here
#

def build_request(solution_hash)

output = ''

prov = $evm.root["service_template_provision_task"]

#Set some things
  # Get the current logged in user
  user = $evm.root['user']
  #$evm.log("info","#{@method} - Inspecting User object:<#{user.inspect}>") if @debug

  if user.nil?
    userid = 'admin'
    user_mail = 'bthurber@redhat.com'
    # Should get rid of these 2 below in the dialog
    #user_first = 'Admin'
    #user_last = 'Administrator'
  else
    userid = user.userid
    user_mail = user.email

    # If currently logged in user email is nil assign a default email address
    user_mail ||= 'bthurber@redhat.com'
    user_first = "Brett"
    user_last = "Thurber"
  end

$evm.log("info","Output of Root Object")
$evm.root.attributes.sort.each { |k, v| $evm.log("info", "\t#{k}: #{v}")}

lampsrv = true
  
if lampsrv == true
    $evm.log("info","lampsrv is a go")
    # arg1 = version
    args = ['1.1']
    # arg2 = templateFields
    args << "name=#{solution_hash[:template_name]}|request_type=template"
    # arg3 = vmFields
    args << "vm_name=#{solution_hash[:vm_name]}|instance_type=#{solution_hash[:instance_type]}|customization_template_id=#{solution_hash[:customization_template_id]}|guest_access_key_pair=#{solution_hash[:guest_access_key_pair]}"
    # arg4 = requester
    args << "owner_email=#{solution_hash[:email]}|owner_last_name=#{solution_hash[:last_name]}|owner_first_name=#{solution_hash[:first_name]}"
    # arg5 = tags
    args << "environment=cloudforms"
    # arg6 = additionalValues
    args << "cloud_network=#{solution_hash[:cloud_network]}"
    # arg7 = emsCustomAttributes
    args << solution_hash.collect { |k, v| "#{k}=#{v}" }.join('|')
    # arg8 = miqCustomAttributes
    args << "security_groups=#{solution_hash[:security_groups]}|availability_zones=#{solution_hash[:availability_zones]}"
    $evm.log("info", "Inline Method: <#{@log_prefix}> - Building provisioning request with the following arguments: <#{args.inspect}>")
    # exit MIQ_ABORT
    $evm.execute('create_provision_request', *args)
else
	$evm.log("info","lampsrv is foo bar, not provisioning")
end

end

def parse_piped_string(text_input, options={})
  return {} unless text_input.kind_of?(String)
  result = {}
  text_input.split('|').each do |value|

    next if value.blank?
    idx = value.index('=')
    next if idx.nil?
    key = !options[:modify_key_name] ? value[0, idx].strip : value[0, idx].strip.to_sym
    result[key] = value[idx+1..-1].strip
  end
  return result
end

## Get variables
solution_id = $evm.root['dialog_solution_id'].to_i
$evm.root['solution_id'] = solution_id
$evm.log("info", "Inline Method: <#{@log_prefix}> - Solution_ID : #{solution_id}") if @debug


  solution_hash= {
      :template_name => "cf-lamp",
      :first_name => "Brett",
      :last_name => "Thurber",
      :email => "bthurber@redhat.com",
      :vm_name => "cf-lamp$n{3}",
      :instance_type => "2",
      :security_groups => "1",
      :cloud_network => "2",
      :availability_zones => "1",
      :customization_template_id => "7",
      :guest_access_key_pair => "2"
  }
  $evm.log("info", "Building request") if @debug

  build_request(solution_hash)

$evm.log("info", "<Inline Method: <#{@log_prefix}> - EVM Service Task Finished")  if @debug

#
#
#
$evm.log("info", "lampsrv Automate Method Ended")
exit MIQ_OK
